import {Util} from '../share';

export class DataPacket {
  // tslint:disable-next-line:variable-name
  private __property: DataPacketProperty;

  constructor() {
    this.__property = new DataPacketProperty();
  }

  get isActive(): boolean {
    return this.__property.isActive;
  }

  set isActive(value: boolean) {
    this.__property.isActive = value;
  }

  get isChecked(): boolean {
    return this.__property.isChecked;
  }

  set isChecked(value: boolean) {
    this.__property.isChecked = value;
  }

  get isSelected(): boolean {
    return this.__property.isSelected;
  }

  set isSelected(value: boolean) {
    this.__property.isSelected = value;
  }

  get isLoading(): boolean {
    return this.__property.isLoading;
  }

  set isLoading(value: boolean) {
    this.__property.isLoading = value;
  }

  get isShow(): boolean {
    return this.__property.isShow;
  }

  set isShow(value: boolean) {
    this.__property.isShow = value;
  }

  get isVisited(): boolean {
    return this.__property.isVisited;
  }

  set isVisited(value: boolean) {
    this.__property.isVisited = value;
  }

  public toString(): string {
    return JSON.stringify(Util.cleanProperty(this));
  }

  protected newDate(date: Date | string = ''): Date | undefined {
    if (!date) {
      return;
    }
    if (typeof date === 'string') {
      date = date.replace(/T/gi, ' ');
      if (date === '0001-01-01 00:00:00') {
        return;
      }
      // tslint:disable-next-line:no-non-null-assertion
      const dateArr = date.match(/\d+/g)!.map(item => {
        return Number.parseInt(item, 10);
      });
      date = new Date(dateArr[0], dateArr[1] - 1, dateArr[2], dateArr[3] || 0, dateArr[4] || 0, dateArr[5] || 0);
    }
    if (date.getTime() >= -2209017600000) {
      return date;
    }
  }

  protected setValue(obj: any): DataPacket {
    for (const prop in obj) {
      if (obj.hasOwnProperty(prop)) {
        this[prop] = obj[prop];
      }
    }
    return this;
  }
}

class DataPacketProperty {
  isActive: boolean;
  isChecked: boolean;
  isLoading: boolean;
  isVisited: boolean;
  isShow: boolean;
  isSelected: boolean;

  constructor() {
    this.isActive = false;
    this.isChecked = false;
    this.isLoading = false;
    this.isVisited = false;
    this.isShow = true;
    this.isSelected = false;
  }
}
