import {DataPacket} from './data-packet.domain';
import {Util} from '../share';

export class DynClass extends DataPacket {
  [key: string]: any;

  constructor(options: {
    [key: string]: any
  } = {}) {
    super();
    for (const key in options) {
      if (options.hasOwnProperty(key)) {
        this[key] = Util.deepClone(options[key]);
      }
    }
  }

  set(key: string, value: any): void {
    this[key] = value;
  }

  forEachKey(callback: (key, value) => void): void {
    for (const key in this) {
      if (this.hasOwnProperty(key) && key !== '__property') {
        callback(key, this[key]);
      }
    }
  }
}
