export class DatePrototypeEx {
  public static apply(): void {
    Date.prototype.toJSON =  () => {
      return this.format('yyyy-MM-ddThh:mm:ss');
    };

    Date.prototype.format =  (fmt) => {
      const o = {
        'M+': this.getMonth() + 1, // 月份
        'd+': this.getDate(), // 日
        'h+': this.getHours(), // 小时
        'm+': this.getMinutes(), // 分
        's+': this.getSeconds(), // 秒
        'q+': Math.floor((this.getMonth() + 3) / 3), // 季度
        'S': this.getMilliseconds(), // 毫秒
      };
      if (/(y+)/.test(fmt)) {
        fmt = fmt.replace(RegExp.$1, (this.getFullYear() + '').substr(4 - RegExp.$1.length));
      }
      for (const k in o) {
        if (new RegExp('(' + k + ')').test(fmt)) {
          // @ts-ignore
          fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (('00' + o[k]).substr(('' + o[k]).length)));
        }
      }
      return fmt;
    };

    Date.prototype.getMonthLastDay = function () {
      const m = this.getMonth();
      return new Date(new Date(this).setMonth(m + 1, 0));
    };
  }
}

