export class StringPrototypeEx {
  public static apply(): void {
    Object.defineProperty(String.prototype, 'byteLength', {
      get: function () {
        let result = 0;
        for (let i = 0; i < this.length; i++) {
          result += this.charCodeAt(i) > 255 ? 2 : 1;
        }
        return result;
      }
    });

    String.prototype.trimAll = function (s: string = '\\s') {
      const regExp = new RegExp(`^(${s}+)|(${s}+)$`, 'g');
      return this.replace(regExp, '');
    };
  }
}

