import {AbstractControl, ValidatorFn} from '@angular/forms';

export class ValidatorEx {
  static telephone(): ValidatorFn {
    return apply;

    function apply(control: AbstractControl): { [key: string]: any } {
      if (!control.value) {
        return null;
      }
      return /^[1]([3-9])[0-9]{9}$/.test(control.value) ? null : {telephone: '非法的手机号'};
    }
  }

  static zipCode(): ValidatorFn {
    return apply;

    function apply(control: AbstractControl): { [key: string]: any } {
      if (!control.value) {
        return null;
      }
      return /^\d{6}$/.test(control.value) ? null : {zipCode: '请输入正确的邮编'};
    }
  }

  static allPhone(): ValidatorFn {
    return apply;

    function apply(control: AbstractControl): { [key: string]: any } {
      if (!control.value) {
        return null;
      }
      return /^(\(\d{3,4}\)|\d{3,4}-|\s)?\d{7,8}$/.test(control.value) ? null : {allPhone: '请输入正确的电话号码'};
    }
  }

  static positiveInteger(): ValidatorFn {
    return apply;

    function apply(control: AbstractControl): { [key: string]: any } {
      if (!control.value) {
        return null;
      }
      return /^\+?[1-9][0-9]*$/.test(control.value) ? null : {positiveInteger: '请输入正整数'};
    }
  }

  static float(): ValidatorFn {
    return apply;

    function apply(control: AbstractControl): { [key: string]: any } {
      if (!control.value) {
        return null;
      }
      return /^[-]?[0-9]+([.][0-9]+)?$/.test(control.value) ? null : {float: '请输入数字'};
    }
  }

  // static include(str: string): ValidatorFn {
  //   return apply;
  //
  //   function apply(control: AbstractControl): { [key: string]: any } {
  //     if (!control.value) {
  //       return null;
  //     }
  //     let regx: RegExp;
  //     if (/&/.test(str)) {
  //       const tmp = str.split('&')
  //     } else if (/\|/.test(str)) {
  //
  //     } else {
  //       regx = new RegExp(`${str}`);
  //     }
  //   }
  // }
}
